package com.fang.mastercontain

import android.app.AppOpsManager
import android.content.Context
import android.os.Binder
import android.os.Build
import android.os.Process
import android.provider.Settings

/**
 * Created by fangmaster on 2018/4/9.
 */
object CheckParmiss {

    fun checkFloatPermission(context:Context) : Boolean {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            val appOpsMgr = context.getSystemService(Context.APP_OPS_SERVICE) as AppOpsManager
            val mode = appOpsMgr.checkOpNoThrow("android:system_alert_window", Process.myUid(), "com.fang.mastercontain")
            return mode == AppOpsManager.MODE_ALLOWED || mode == AppOpsManager.MODE_IGNORED
        }
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.O) {
            return Settings.canDrawOverlays(context)
        }
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
            var cls = Class.forName("android.content.Context")
            val declaredField = cls.getDeclaredField("APP_OPS_SERVICE")
            declaredField.isAccessible = true
            var obj = declaredField.get(cls) as? String ?: return false
            val str2 = obj
            obj = cls.getMethod("getSystemService", String::class.java).invoke(this, str2)  as String
            cls = Class.forName("android.app.AppOpsManager")
            val declaredField2 = cls.getDeclaredField("MODE_ALLOWED")
            declaredField2.isAccessible = true
            val checkOp = cls.getMethod("checkOp", Integer.TYPE, Integer.TYPE, String::class.java)
            val result = checkOp.invoke(obj, 24, Binder.getCallingUid(), "com.fang.mastercontain") as Int
            return result == declaredField2.getInt(cls)
        }
        if (Build.VERSION.SDK_INT < Build.VERSION_CODES.KITKAT) {
            return true
        }
        return false
    }
}

